{ 
  -= Module PERGUNTA =-

  Project: CaraaraC 2
  Programmed by: Marcelo Silveira
  E-mail: flamar98@hotmail.com
  Date: November 2018
  License: GNU-GPL, v. 3.x

  Constantes e Variáveis
  pergunta_verbos - Verbos para cada tipo de pergunta.
  pergunta_map - Mapeia os verbos com os substantivos da pergunta.
  carac_map - Mapeia o código da característica de acordo com a posição do menu gráfico.
  tipo_map - Mapeia o código do tipo de acordo com a posição do menu gráfico.

  Procedures e functions
  _get_ct - Converte do menu gráfico para característica e tipo.
  _pergunta_direta - Formula pergunta direta pelo personagem. Retorna string.
  _pergunta_carac - Formula pergunta sobre o nome do personagem. Retorna string. 
  pergunta_sim - Pergunta se sim ou não de acordo com um personagem e a posição do menu gráfico. Retorna True ou False.
  pergunta_formula - Formula a pergunta de acordo com o código passado. Retorna string.

  Características
  sexo, cor, idade, cabelo_tipo, cabelo_tam, cabelo_cor, pelo, olhos, boca, nariz, outros
}

type perg = string[40];

const pergunta_verbos : array[1..3] of string[11] = ('Is', 'Has', 'Wears');
      pergunta_map : array[1..11,1..4] of byte = ((1,1,0,0),(1,1,1,0),(1,1,0,0),(2,2,2,0),(2,2,0,0),(2,2,2,2),
                                                  (2,2,0,0),(2,2,0,0),(2,2,0,0),(2,2,0,0),(3,3,0,0));
      carac_map : array[1..26] of byte = (1,1,2,2,2,3,3,4,4,4,5,5,6,6,6,6,7,7,8,8,9,9,10,10,11,11);
      tipo_map : array[1..26] of byte =  (1,2,1,2,3,1,2,1,2,3,1,2,1,2,3,4,1,2,1,2,1,2,1,2,1,2);


{ Private }

procedure _get_ct(var c, t, menu_pos : byte);
begin
  c := carac_map[menu_pos];
  t := tipo_map[menu_pos];
end;

function _pergunta_direta(pers : byte) : perg;
begin
  _pergunta_direta := 'Does your character is ' + lista_nomes[pers] + '?';
end;

function _pergunta_carac(menu_pos : byte) : perg;
var carac, tipo : byte;
begin
  _get_ct(carac, tipo, menu_pos);
  _pergunta_carac := pergunta_verbos[pergunta_map[carac, tipo]] + ' he/she ' + 
                       carac_tipo[carac, tipo] + '?';
end;


{ Public }

procedure pergunta_get_ct(var c, t, menu_pos : byte);
begin
  _get_ct(c, t, menu_pos);
end;

function pergunta_sim(pers, menu_pos : byte) : boolean;
var carac, tipo : byte;
begin
  _get_ct(carac, tipo, menu_pos);
  pergunta_sim := lista_personagens[pers, carac] = tipo;

  if (carac=11) and (lista_personagens[pers, carac] = 3) then
    pergunta_sim := true;
end;


function pergunta_formula(pers, menu_pos : byte) : perg;
begin
  if (menu_pos < 27) then
    pergunta_formula := _pergunta_carac(menu_pos)
  else
    pergunta_formula := _pergunta_direta(pers);
end;
